package com.ruoyi.bst.ad.mapper;

import java.util.List;
import com.ruoyi.bst.ad.domain.Ad;
import com.ruoyi.bst.ad.domain.AdVO;
import com.ruoyi.bst.ad.domain.AdQuery;
import org.apache.ibatis.annotations.Param;
import org.springframework.security.core.parameters.P;

/**
 * 广告Mapper接口
 *
 * @author ruoyi
 * @date 2025-04-01
 */
public interface AdMapper
{
    /**
     * 查询广告
     *
     * @param adId 广告主键
     * @return 广告
     */
    AdVO selectAdByAdId(Long adId);

    /**
     * 查询广告列表
     *
     * @param query 广告
     * @return 广告集合
     */
    List<AdVO> selectAdList(@Param("query")AdQuery query);

    /**
     * 新增广告
     *
     * @param ad 广告
     * @return 结果
     */
    int insertAd(Ad ad);

    /**
     * 批量新增广告
     */
    int batchInsert(@Param("list") List<? extends Ad> list);

    /**
     * 批量修改广告
     */
    int batchUpdate(@Param("list") List<? extends Ad> list);

    /**
     * 修改广告
     *
     * @param ad 广告
     * @return 结果
     */
    public int updateAd(@Param("data") Ad ad);

    /**
     * 删除广告
     *
     * @param adId 广告主键
     * @return 结果
     */
    int deleteAdByAdId(Long adId);

    /**
     * 批量删除广告
     *
     * @param adIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteAdByAdIds(@Param("array") List<Long> adIds);

    AdVO selectOne(@Param("query") AdQuery query);

    public int logicalDel(@Param("array") List<Long> adIds);

    int countByAreaId(@Param("areaId") Long areaId, @Param("adId") Long adId);

    List<AdVO> selectAdByAreaId(@Param("areaId") Long areaId);

    public int updateByQuery(@Param("data") Ad data,@Param("query") AdQuery query);
}
